package com.systemation.lisa.test.filter;

import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.Iterator;

import org.apache.commons.lang3.builder.ReflectionToStringBuilder;
import org.apache.commons.lang3.builder.ToStringStyle;
import org.apache.log4j.Logger;
import org.w3c.dom.Element;

import com.itko.lisa.test.FilterBaseImpl;
import com.itko.lisa.test.TestDefException;
import com.itko.lisa.test.TestExec;
import com.itko.lisa.test.TestRunException;
import com.itko.lisa.vse.stateful.model.Request;
import com.itko.lisa.vse.stateful.model.Streamer;
import com.itko.util.Parameter;
import com.itko.util.ParameterList;
import com.itko.util.XMLUtils;
import com.mifmif.common.regex.Generex;


public class CalculateDateDifference
  extends FilterBaseImpl
{
  private static final long serialVersionUID = 0L;
  private static final Logger logger = Logger.getLogger(CalculateDateDifference.class);
  private static final String STARTDATETIME_PARAM = "startDatetime";
  private static final String ENDDATETIME_PARAM = "endDatetime";
  private static final String PROP_PARAM = "startDatetime";
  private String prop;
  private String startDatetime;
  private String simpleDateFormatStart;
  private String endDatetime;
  private String simpleDateFormatEnd;
  //private String resultDatetime;
  private String simpleDateFormatResult;
  
  public CalculateDateDifference()
  {
    super.setThreadSafe(true);
    if (logger.isDebugEnabled())
    {
      logger.debug("Created Filter: " + getClass().getCanonicalName());
      logger.debug(toString());
    }
  }
  
  public ParameterList getParameters()
  {	  
	    ParameterList localParameterList = new ParameterList();
	    localParameterList.addParameter(new Parameter("New Property", "prop", this.prop, String.class));
	    localParameterList.addParameter(new Parameter("Date pattern property", "simpleDateFormatResult", this.simpleDateFormatResult, String.class));
	    localParameterList.addParameter(new Parameter("Start Datetime", "startDatetime", this.startDatetime, TestExec.PROPERTY_PARAM_TYPE));
	    localParameterList.addParameter(new Parameter("Date pattern start datetime", "simpleDateFormatStart", this.simpleDateFormatStart, String.class));
	    localParameterList.addParameter(new Parameter("End Datetime", "endDatetime", this.endDatetime, TestExec.PROPERTY_PARAM_TYPE));
	    localParameterList.addParameter(new Parameter("Date pattern end datetime", "simpleDateFormatEnd", this.simpleDateFormatEnd, String.class));

    if (logger.isDebugEnabled())
    {
	Iterator<Parameter> localIterator = localParameterList.iterator();
      while (localIterator.hasNext())
      {
        Parameter localParameter = (Parameter)localIterator.next();
        logger.debug("Parameter [name,value] ==> [" + localParameter.getName() + "," + localParameter.getValue() + "]");
        logger.debug(ReflectionToStringBuilder.toString(localParameter));
      }
    }
    return localParameterList;
  }
  
  
  
  
  public boolean subPostFilter(TestExec paramTestExec)
    throws TestRunException
  {
	  
//	// Get pattern + Generate random String
//	Generex generex = new Generex(RegExPattern);
//	String randomStr = generex.random();
	
	  //-----------------put code here-------------------------------
	  
		Date d1 = null;
		Date d2 = null;
		Date d3 = null;
		SimpleDateFormat sdfd1 = new SimpleDateFormat(simpleDateFormatStart);
		SimpleDateFormat sdfd2 = new SimpleDateFormat(simpleDateFormatEnd);
		SimpleDateFormat sdfres = new SimpleDateFormat(simpleDateFormatResult);

		SimpleDateFormat sdfd3 = new SimpleDateFormat("SSSSSSSSS");

		String result = null;

		try {
			
		    
//			if (!isValidDate(startDatetime, simpleDateFormatStart)){
//			    String str1 = paramTestExec.parseInState(this.startDatetime);
//			    Object localObject = paramTestExec.getStateObject(this.startDatetime);
//			    boolean bool = localObject instanceof String;
//			    Request localRequest = bool ? (Request)Streamer.fromXML((String)localObject) : (Request)localObject;
//			    if (localRequest != null)
//			    {
//	   		      	String str2 = (String)paramTestExec.getStateValue(str1);
//			        paramTestExec.setStateValue(startDatetime, str2);
//			    }
//			}
//			
//			if (!isValidDate(endDatetime, simpleDateFormatEnd)){
//			    String str1 = paramTestExec.parseInState(this.endDatetime);
//			    Object localObject = paramTestExec.getStateObject(this.endDatetime);
//			    boolean bool = localObject instanceof String;
//			    Request localRequest = bool ? (Request)Streamer.fromXML((String)localObject) : (Request)localObject;
//			    if (localRequest != null)
//			    {
//	   		      	String str2 = (String)paramTestExec.getStateValue(str1);
//			        paramTestExec.setStateValue(endDatetime, str2);
//			    }
//			}
			
		      Object objToString = paramTestExec.getStateValue(startDatetime);
		      if ((objToString instanceof String))
		      {
		        String trimmed = ((String)objToString);
		        paramTestExec.setStateValue(startDatetime, trimmed);
		      }
		      
		      objToString = paramTestExec.getStateValue(endDatetime);
		      if ((objToString instanceof String))
		      {
		        String trimmed = ((String)objToString);
		        paramTestExec.setStateValue(endDatetime, trimmed);
		      }
			
			d1 = sdfd1.parse(startDatetime);
			d2 = sdfd2.parse(endDatetime);

			// in milliseconds
			long diff = d2.getTime() - d1.getTime();
			d3 = sdfd3.parse(String.valueOf(diff)); 	// create date
			result = sdfres.format(d3); 				// create string from date and dateformat
										
		} catch (Exception e) {
			e.printStackTrace();
		}

	//------------------------------------------------------------------	
	  
	// return value in property  
	paramTestExec.setStateValue( prop, result );
	

    if (logger.isDebugEnabled()) {
      logger.debug("Processing calculate date difference: " + result);
    }
    return false;
  }
  
  
  public boolean isValidDate(String value, String format) {
      Date date = null;
      try {
          SimpleDateFormat sdf = new SimpleDateFormat(format);
          date = sdf.parse(value);
          if (!value.equals(sdf.format(date))) {
              date = null;
          }
      } catch (Exception e) {
          e.printStackTrace();
      }
      return date != null;
  }
  
  
  
  public boolean subPreFilter(TestExec paramTestExec)
  {
    return true;
  }
  
  public void initialize(Element paramElement)
    throws TestDefException
  {
    super.initialize(paramElement);
	this.prop = XMLUtils.findChildGetItsText(paramElement, "prop");
    this.startDatetime = XMLUtils.getAttributeOrChildText(paramElement, "startDatetime");
    this.simpleDateFormatStart = XMLUtils.findChildGetItsText(paramElement, "simpleDateFormatStart");
    this.endDatetime = XMLUtils.getAttributeOrChildText(paramElement, "endDatetime");
    this.simpleDateFormatEnd = XMLUtils.findChildGetItsText(paramElement, "simpleDateFormatEnd");
    this.simpleDateFormatResult = XMLUtils.findChildGetItsText(paramElement, "simpleDateFormatResult");
  }
  
  public String getTypeName()
  {
    return "Calculate difference between two dates";
  }
  
  public String toString()
  {
    return ReflectionToStringBuilder.reflectionToString(this, ToStringStyle.MULTI_LINE_STYLE);
  }
}

